---
title: HTMLObjectElement.setCustomValidity
slug: Web/API/HTMLObjectElement/setCustomValidity
tags:
  - API
  - HTML DOM
  - HTMLObjectElement
  - Method
  - NeedsExample
  - Reference
  - setCustomValidity()
---
<div>{{APIRef("HTML DOM")}}</div>

<p class="summary">The <strong><code>setCustomValidity()</code></strong> method of the {{domxref("HTMLObjectElement")}} interface sets a custom validity message for the element.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">HTMLObjectElement.setCustomValidity(message);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
	<dt>error</dt>
	<dd>The message to use for validity errors.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>{{jsxref('undefined')}}</p>

<h3 id="Exceptions">Exceptions</h3>

<p>None.</p>

<h2 id="Examples">Examples</h2>

<p>In this example, we pass the ID of an input element, and set different error messages depending on whether the value is missing, too low or too high. Additionally you <em>must</em> call the <a href="/en-US/docs/Web/API/HTMLFormElement/reportValidity">reportValidity</a> method on the same element or nothing will happen.</p>

<pre class="brush: js notranslate">function validate(inputID)
{
 var input = document.getElementById(inputID);
 var validityState_object = input.validity;

 if (validityState_object.valueMissing)
 {
  input.setCustomValidity('You gotta fill this out, yo!');
  input.reportValidity();
 }
 else if (validityState_object.rangeUnderflow)
 {
  input.setCustomValidity('We need a higher number!');
  input.reportValidity();
 }
 else if (validityState_object.rangeOverflow)
 {
  input.setCustomValidity('Thats too high!');
  input.reportValidity();
 }
 else
 {
  input.setCustomValidity('');
  input.reportValidity();
 }
}</pre>

<p>It's vital to set the message to an empty string if there are no errors. As long as the error message is not null, the form will not pass validation and will not be submitted.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<tbody>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
		<tr>
			<td>{{SpecName('HTML WHATWG','#dom-cva-setcustomvalidity','setCustomValidity')}}</td>
			<td>{{Spec2('HTML WHATWG')}}</td>
			<td>Initial definition.</td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.HTMLObjectElement.setCustomValidity")}}</p>

<h2 id="See_also">See also</h2>

<ul>
	<li>{{domxref('validityState')}}</li>
	<li>{{domxref('validityState.valueMissing')}}</li>
	<li>{{domxref('validityState.typeMismatch')}}</li>
	<li>{{domxref('validityState.patternMismatch')}}</li>
	<li>{{domxref('validityState.tooLong')}}</li>
	<li>{{domxref('validityState.tooShort')}}</li>
	<li>{{domxref('validityState.rangeUnderflow')}}</li>
	<li>{{domxref('validityState.rangeOverflow')}}</li>
	<li>{{domxref('validityState.stepMismatch')}}</li>
	<li>{{domxref('validityState.valid')}}</li>
	<li>{{domxref('validityState.customError')}}</li>
</ul>
